/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
	"reflect"
)


// CxTemplateAPIService CxTemplateAPI service
type CxTemplateAPIService service

type ApiDeleteOrganizationsOrganizationIdCxTemplatesIdRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	id string
}

func (r ApiDeleteOrganizationsOrganizationIdCxTemplatesIdRequest) Execute() (*http.Response, error) {
	return r.ApiService.DeleteOrganizationsOrganizationIdCxTemplatesIdExecute(r)
}

/*
DeleteOrganizationsOrganizationIdCxTemplatesId Delete cx template

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param id
 @return ApiDeleteOrganizationsOrganizationIdCxTemplatesIdRequest
*/
func (a *CxTemplateAPIService) DeleteOrganizationsOrganizationIdCxTemplatesId(ctx context.Context, organizationId string, id string) ApiDeleteOrganizationsOrganizationIdCxTemplatesIdRequest {
	return ApiDeleteOrganizationsOrganizationIdCxTemplatesIdRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		id: id,
	}
}

// Execute executes the request
func (a *CxTemplateAPIService) DeleteOrganizationsOrganizationIdCxTemplatesIdExecute(r ApiDeleteOrganizationsOrganizationIdCxTemplatesIdRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.DeleteOrganizationsOrganizationIdCxTemplatesId")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiDeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	installationId string
}

func (r ApiDeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest) Execute() (*http.Response, error) {
	return r.ApiService.DeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdExecute(r)
}

/*
DeleteOrganizationsOrganizationIdCxTemplatesInstallationsId Delete installation

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param installationId
 @return ApiDeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest
*/
func (a *CxTemplateAPIService) DeleteOrganizationsOrganizationIdCxTemplatesInstallationsId(ctx context.Context, organizationId string, installationId string) ApiDeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest {
	return ApiDeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		installationId: installationId,
	}
}

// Execute executes the request
func (a *CxTemplateAPIService) DeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdExecute(r ApiDeleteOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodDelete
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.DeleteOrganizationsOrganizationIdCxTemplatesInstallationsId")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations/{installation_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"installation_id"+"}", url.PathEscape(parameterValueToString(r.installationId, "installationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	tags *[]string
	languages *[]string
	formality *string
	global *bool
	shared *bool
}

// Tags filter
func (r ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest) Tags(tags []string) ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest {
	r.tags = &tags
	return r
}

// Languages filter
func (r ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest) Languages(languages []string) ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest {
	r.languages = &languages
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest) Formality(formality string) ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest {
	r.formality = &formality
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest) Global(global bool) ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest {
	r.global = &global
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest) Shared(shared bool) ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest {
	r.shared = &shared
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest) Execute() (*GetOrganizationsOrganizationIdCxTemplatesGlobalList200Response, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesGlobalListExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplatesGlobalList Get list of global cx templates

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest
*/
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesGlobalList(ctx context.Context) ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return GetOrganizationsOrganizationIdCxTemplatesGlobalList200Response
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesGlobalListExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesGlobalListRequest) (*GetOrganizationsOrganizationIdCxTemplatesGlobalList200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrganizationsOrganizationIdCxTemplatesGlobalList200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.GetOrganizationsOrganizationIdCxTemplatesGlobalList")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cx-templates"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.tags != nil {
		t := *r.tags
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", t, "multi")
		}
	}
	if r.languages != nil {
		t := *r.languages
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", t, "multi")
		}
	}
	if r.formality != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "formality", r.formality, "")
	}
	if r.global != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "global", r.global, "")
	}
	if r.shared != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "shared", r.shared, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesIdRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	id string
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesIdRequest) Execute() (*CxTemplate, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesIdExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplatesId Get one cx template

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param id
 @return ApiGetOrganizationsOrganizationIdCxTemplatesIdRequest
*/
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesId(ctx context.Context, organizationId string, id string) ApiGetOrganizationsOrganizationIdCxTemplatesIdRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesIdRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		id: id,
	}
}

// Execute executes the request
//  @return CxTemplate
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesIdExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesIdRequest) (*CxTemplate, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplate
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.GetOrganizationsOrganizationIdCxTemplatesId")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	statuses *[]string
	templateIds *[]string
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest) Statuses(statuses []string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest {
	r.statuses = &statuses
	return r
}

// template ids
func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest) TemplateIds(templateIds []string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest {
	r.templateIds = &templateIds
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest) Execute() (*GetOrganizationsOrganizationIdCxTemplatesInstallations200Response, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesInstallationsExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplatesInstallations Get list of installations

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest
*/
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallations(ctx context.Context, organizationId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
	}
}

// Execute executes the request
//  @return GetOrganizationsOrganizationIdCxTemplatesInstallations200Response
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsRequest) (*GetOrganizationsOrganizationIdCxTemplatesInstallations200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrganizationsOrganizationIdCxTemplatesInstallations200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.GetOrganizationsOrganizationIdCxTemplatesInstallations")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.statuses != nil {
		t := *r.statuses
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "statuses[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "statuses[]", t, "multi")
		}
	}
	if r.templateIds != nil {
		t := *r.templateIds
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "template_ids[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "template_ids[]", t, "multi")
		}
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	installationId string
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest) Execute() (*CxTemplateInstallation, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesInstallationsIdExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplatesInstallationsId Get installation by id

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param installationId
 @return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest
*/
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsId(ctx context.Context, organizationId string, installationId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		installationId: installationId,
	}
}

// Execute executes the request
//  @return CxTemplateInstallation
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsIdExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest) (*CxTemplateInstallation, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplateInstallation
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.GetOrganizationsOrganizationIdCxTemplatesInstallationsId")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations/{installation_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"installation_id"+"}", url.PathEscape(parameterValueToString(r.installationId, "installationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	installationId string
	interactionId *string
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest) InteractionId(interactionId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest {
	r.interactionId = &interactionId
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest) Execute() (*GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasks200Response, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasks Get installation tasks

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param installationId
 @return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest
*/
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasks(ctx context.Context, organizationId string, installationId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		installationId: installationId,
	}
}

// Execute executes the request
//  @return GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasks200Response
func (a *CxTemplateAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasksRequest) (*GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasks200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasks200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.GetOrganizationsOrganizationIdCxTemplatesInstallationsIdTasks")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations/{installation_id}/tasks"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"installation_id"+"}", url.PathEscape(parameterValueToString(r.installationId, "installationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.interactionId != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "interaction_id", r.interactionId, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	id string
	cxTemplateInstallationCreateData *CxTemplateInstallationCreateData
}

func (r ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest) CxTemplateInstallationCreateData(cxTemplateInstallationCreateData CxTemplateInstallationCreateData) ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest {
	r.cxTemplateInstallationCreateData = &cxTemplateInstallationCreateData
	return r
}

func (r ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest) Execute() (*CxTemplateInstallation, *http.Response, error) {
	return r.ApiService.PostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsExecute(r)
}

/*
PostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallations Init installation for cx template

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id
 @return ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest
*/
func (a *CxTemplateAPIService) PostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallations(ctx context.Context, id string) ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest {
	return ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return CxTemplateInstallation
func (a *CxTemplateAPIService) PostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsExecute(r ApiPostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallationsRequest) (*CxTemplateInstallation, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplateInstallation
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.PostOrganizationsOrganizationIdCxTemplatesGlobalIdInstallations")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cx-templates/{id}/installations"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.cxTemplateInstallationCreateData
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiPostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	installationId string
}

func (r ApiPostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishRequest) Execute() (*http.Response, error) {
	return r.ApiService.PostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishExecute(r)
}

/*
PostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinish Finish installation

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param installationId
 @return ApiPostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishRequest
*/
func (a *CxTemplateAPIService) PostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinish(ctx context.Context, organizationId string, installationId string) ApiPostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishRequest {
	return ApiPostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		installationId: installationId,
	}
}

// Execute executes the request
func (a *CxTemplateAPIService) PostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishExecute(r ApiPostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinishRequest) (*http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.PostOrganizationsOrganizationIdCxTemplatesInstallationsIdFinish")
	if err != nil {
		return nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations/{installation_id}/finish"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"installation_id"+"}", url.PathEscape(parameterValueToString(r.installationId, "installationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarHTTPResponse, newErr
	}

	return localVarHTTPResponse, nil
}

type ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	id string
	cxTemplateMutableData *CxTemplateMutableData
}

func (r ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest) CxTemplateMutableData(cxTemplateMutableData CxTemplateMutableData) ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest {
	r.cxTemplateMutableData = &cxTemplateMutableData
	return r
}

func (r ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest) Execute() (*CxTemplate, *http.Response, error) {
	return r.ApiService.PutOrganizationsOrganizationIdCxTemplatesIdExecute(r)
}

/*
PutOrganizationsOrganizationIdCxTemplatesId Update one cx template

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param id
 @return ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest
*/
func (a *CxTemplateAPIService) PutOrganizationsOrganizationIdCxTemplatesId(ctx context.Context, organizationId string, id string) ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest {
	return ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		id: id,
	}
}

// Execute executes the request
//  @return CxTemplate
func (a *CxTemplateAPIService) PutOrganizationsOrganizationIdCxTemplatesIdExecute(r ApiPutOrganizationsOrganizationIdCxTemplatesIdRequest) (*CxTemplate, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplate
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.PutOrganizationsOrganizationIdCxTemplatesId")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.cxTemplateMutableData
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	id string
	putOrganizationsOrganizationIdCxTemplatesIdStatusRequest *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest
}

func (r ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest(putOrganizationsOrganizationIdCxTemplatesIdStatusRequest PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest {
	r.putOrganizationsOrganizationIdCxTemplatesIdStatusRequest = &putOrganizationsOrganizationIdCxTemplatesIdStatusRequest
	return r
}

func (r ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) Execute() (*CxTemplate, *http.Response, error) {
	return r.ApiService.PutOrganizationsOrganizationIdCxTemplatesIdStatusExecute(r)
}

/*
PutOrganizationsOrganizationIdCxTemplatesIdStatus Update status of cx template

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param id
 @return ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest
*/
func (a *CxTemplateAPIService) PutOrganizationsOrganizationIdCxTemplatesIdStatus(ctx context.Context, organizationId string, id string) ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest {
	return ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		id: id,
	}
}

// Execute executes the request
//  @return CxTemplate
func (a *CxTemplateAPIService) PutOrganizationsOrganizationIdCxTemplatesIdStatusExecute(r ApiPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) (*CxTemplate, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplate
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.PutOrganizationsOrganizationIdCxTemplatesIdStatus")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates/{id}/status"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.putOrganizationsOrganizationIdCxTemplatesIdStatusRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest struct {
	ctx context.Context
	ApiService *CxTemplateAPIService
	organizationId string
	installationId string
	cxTemplateInstallationMutableData *CxTemplateInstallationMutableData
}

func (r ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest) CxTemplateInstallationMutableData(cxTemplateInstallationMutableData CxTemplateInstallationMutableData) ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest {
	r.cxTemplateInstallationMutableData = &cxTemplateInstallationMutableData
	return r
}

func (r ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest) Execute() (*CxTemplateInstallation, *http.Response, error) {
	return r.ApiService.PutOrganizationsOrganizationIdCxTemplatesInstallationsIdExecute(r)
}

/*
PutOrganizationsOrganizationIdCxTemplatesInstallationsId Update installation

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param installationId
 @return ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest
*/
func (a *CxTemplateAPIService) PutOrganizationsOrganizationIdCxTemplatesInstallationsId(ctx context.Context, organizationId string, installationId string) ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest {
	return ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		installationId: installationId,
	}
}

// Execute executes the request
//  @return CxTemplateInstallation
func (a *CxTemplateAPIService) PutOrganizationsOrganizationIdCxTemplatesInstallationsIdExecute(r ApiPutOrganizationsOrganizationIdCxTemplatesInstallationsIdRequest) (*CxTemplateInstallation, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplateInstallation
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplateAPIService.PutOrganizationsOrganizationIdCxTemplatesInstallationsId")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations/{installation_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"installation_id"+"}", url.PathEscape(parameterValueToString(r.installationId, "installationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.cxTemplateInstallationMutableData
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
